#!/usr/bin/env bash
export PATH=$PATH:/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:~/bin

cur_dir=$(pwd)
C_V=$1
A_V=$2

if [ "${C_V}" = "" ]; then
    C_V="3.1.1"
else
    C_V=$1
fi

if [ "${A_V}" = "" ]; then
    A_V="1.35.0"
else
    A_V=$2
fi

Check_Tar()
{
    if grep -Eqi "CentOS" /etc/issue || grep -Eq "CentOS" /etc/*-release; then
            for packages in tar wget bzip2;
            do yum -y install $packages; done
    elif grep -Eqi "Debian" /etc/issue || grep -Eq "Debian" /etc/*-release; then
            for packages in wget tar bzip2;
            do apt-get --no-install-recommends install -y $packages; done
    fi
}

Download_Files()
{
    local URL=$1
    local FileName=$2
    if [ -s "${FileName}" ]; then
        echo "${FileName} [found]"
    else
        echo "Notice: ${FileName} not found!!!download now..."
        wget -c --progress=bar:force --prefer-family=IPv4 --no-check-certificate ${URL}
    fi
}

Color_Text()
{
  echo -e " \e[0;$2m$1\e[0m"
}

Echo_Blue()
{
  echo $(Color_Text "$1" "34")
}

Check_Tar
cd ${cur_dir}/src
Echo_Blue "!! Installing Cloudreve... "
Download_Files https://github.com/cloudreve/Cloudreve/releases/download/${C_V}/cloudreve_${C_V}_linux_amd64.tar.gz cloudreve_${C_V}_linux_amd64.tar.gz
tar xzf cloudreve_${C_V}_linux_amd64.tar.gz
mkdir /usr/local/cloudreve
mv ${cur_dir}/src/cloudreve /usr/local/cloudreve
nohup /usr/local/cloudreve/cloudreve &
\cp ${cur_dir}/conf/cloudreve.service /usr/lib/systemd/system/cloudreve.service
systemctl daemon-reload
systemctl enable cloudreve


Echo_Blue "!! Installing Aria2... "
Download_Files https://github.com/q3aql/aria2-static-builds/releases/download/v${A_V}/aria2-${A_V}-linux-gnu-64bit-build1.tar.bz2 aria2-${A_V}-linux-gnu-64bit-build1.tar.bz2
tar xjf aria2-${A_V}-linux-gnu-64bit-build1.tar.bz2
mv ${cur_dir}/src/aria2-${A_V}-linux-gnu-64bit-build1 /usr/local/aria2
mkdir /usr/local/aria2/conf
\cp ${cur_dir}/conf/aria2.conf /usr/local/aria2/conf/aria2.conf
\cp ${cur_dir}/conf/dht.dat /usr/local/aria2/conf/dht.dat
\cp ${cur_dir}/conf/aria2.service /usr/lib/systemd/system/aria2.service
kill -9 $(pidof cloudreve)
\cp nohup.out ${cur_dir}/cloudreve.log
rm -rf nohup.out
systemctl daemon-reload
systemctl enable aria2
systemctl start aria2
systemctl start cloudreve
exit